import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Background here.
 * 
 * @author GeneralBrae
 * @version 0.1.3
 */
public class Background extends World
{
    
    //Create the arrays that store the pattern's coordinates
    public int[] xcoords =
            {168,200,200,200,200,232,232,232,232,232,232,264,264,264,264,264,264,264,264,296,296,296,296,296,296,296,296,328,328,328,328,328,328,328,328,360,360,360,360,360,360,360,360,392,392,392,392,392,392,392,392,424,424,424,424,424,424,424,424,456,456,456,456,456,456,456,456,488,488,488,488,488,488,488,488,520,520,520,520,520,520,552,552,552,552,584,616};
            
    public int[] ycoords =
            {280,140,260,300,420,140,220,260,300,340,420,140,180,220,260,300,340,380,420,140,180,220,260,300,340,380,420,140,180,220,260,300,340,380,420,140,180,220,260,300,340,380,420,140,180,220,260,300,340,380,420,140,180,220,260,300,340,380,420,140,180,220,260,300,340,380,420,140,180,220,260,300,340,380,420,140,220,260,300,340,420,140,260,300,420,280,280};
   
    //Create the array containing the class names
    public String[] classes = 
            {"B1", "B2", "B3", "B4", "B5", "B6", "B7", "B8", "B9", "D1", "D2", "D3", "D4", "D5", "D6", "D7", "D8", "D9", "N1", "N2", "N3", "N4", "N5", "N6", "N7", "N8", "N9", "North", "East", "South", "West", "Red", "Green", "White", "F1", "F2", "F3", "F4", "Spring", "Summer", "Autumn", "Winter"};
    
      
    public Actor[] createClasses = {};  
    
    /**
     * Constructor for objects of class Background.
     * 
     */
    public Background()
    {    
        // Create a new world with 750x560 cells with a cell size of 1x1 pixels.
        super(750, 560, 1); 
        CreatePattern();
    }
    
    /**
     * Generate a set pattern with a random distribution of the pieces.
     */
    private void CreatePattern()
    {
        
        CreateClasses();
                                          
        for (int i = 0; i < 87; i++)
        {
            int randomNumber = Greenfoot.getRandomNumber(144);
            addObject (createClasses[randomNumber], xcoords[i], ycoords[i]);    
        }
    }
    
    private void CreateClasses()
    {
        createClasses = new Actor [144];
        
        //Bamboo
        createClasses[0] = new B1(1);        
        createClasses[1] = new B1(1);        
        createClasses[2] = new B1(1);        
        createClasses[3] = new B1(1);        
        
        createClasses[4] = new B2(2);        
        createClasses[5] = new B2(2);        
        createClasses[6] = new B2(2);    
        createClasses[7] = new B2(2);        
        
        createClasses[8] = new B3(3);        
        createClasses[9] = new B3(3);        
        createClasses[10] = new B3(3);        
        createClasses[11] = new B3(3);        
        
        createClasses[12] = new B4(4);        
        createClasses[13] = new B4(4);        
        createClasses[14] = new B4(4);        
        createClasses[15] = new B4(4);        
        
        createClasses[16] = new B5(5);        
        createClasses[17] = new B5(5);        
        createClasses[18] = new B5(5);        
        createClasses[19] = new B5(5);        
        
        createClasses[20] = new B6(6);        
        createClasses[21] = new B6(6);        
        createClasses[22] = new B6(6);        
        createClasses[23] = new B6(6);        
        
        createClasses[24] = new B7(7);        
        createClasses[25] = new B7(7);        
        createClasses[26] = new B7(7);        
        createClasses[27] = new B7(7);        
        
        createClasses[28] = new B8(8);        
        createClasses[29] = new B8(8);        
        createClasses[30] = new B8(8);        
        createClasses[31] = new B8(8);        
        
        createClasses[32] = new B9(9);        
        createClasses[33] = new B9(9);        
        createClasses[34] = new B9(9);        
        createClasses[35] = new B9(9);
        
        
        //Dots        
        createClasses[36] = new D1(10);        
        createClasses[37] = new D1(10);       
        createClasses[38] = new D1(10);        
        createClasses[39] = new D1(10);
        
        createClasses[40] = new D2(11);        
        createClasses[41] = new D2(11);        
        createClasses[42] = new D2(11);        
        createClasses[43] = new D2(11);
        
        createClasses[44] = new D3(12);
        createClasses[45] = new D3(12);
        createClasses[46] = new D3(12);
        createClasses[47] = new D3(12);
        
        createClasses[48] = new D4(13);
        createClasses[49] = new D4(13);
        createClasses[50] = new D4(13);
        createClasses[51] = new D4(13);
        
        createClasses[52] = new D5(14);
        createClasses[53] = new D5(14);
        createClasses[54] = new D5(14);
        createClasses[55] = new D5(14);
        
        createClasses[56] = new D6(15);
        createClasses[57] = new D6(15);
        createClasses[58] = new D6(15);
        createClasses[59] = new D6(15);
        
        createClasses[60] = new D7(16);
        createClasses[61] = new D7(16);
        createClasses[62] = new D7(16);
        createClasses[63] = new D7(16);
        
        createClasses[64] = new D8(17);
        createClasses[65] = new D8(17);
        createClasses[66] = new D8(17);
        createClasses[67] = new D8(17);
        
        createClasses[68] = new D9(18);
        createClasses[69] = new D9(18);
        createClasses[70] = new D9(18);
        createClasses[71] = new D9(18);
        
        
        //Numbers
        createClasses[72] = new N1(19);
        createClasses[73] = new N1(19);
        createClasses[74] = new N1(19);
        createClasses[75] = new N1(19);
        
        createClasses[76] = new N2(20);
        createClasses[77] = new N2(20);
        createClasses[78] = new N2(20);
        createClasses[79] = new N2(20);
        
        createClasses[80] = new N3(21);
        createClasses[81] = new N3(21);
        createClasses[82] = new N3(21);
        createClasses[83] = new N3(21);
        
        createClasses[84] = new N4(22);
        createClasses[85] = new N4(22);
        createClasses[86] = new N4(22);
        createClasses[87] = new N4(22);
        
        createClasses[88] = new N5(23);
        createClasses[89] = new N5(23);
        createClasses[90] = new N5(23);
        createClasses[91] = new N5(23);
        
        createClasses[92] = new N6(24);
        createClasses[93] = new N6(24);
        createClasses[94] = new N6(24);
        createClasses[95] = new N6(24);
        
        createClasses[96] = new N7(25);
        createClasses[97] = new N7(25);
        createClasses[98] = new N7(25);
        createClasses[99] = new N7(25);
        
        createClasses[100] = new N8(26);
        createClasses[101] = new N8(26);
        createClasses[102] = new N8(26);
        createClasses[103] = new N8(26);
        
        createClasses[104] = new N9(27);
        createClasses[105] = new N9(27);
        createClasses[106] = new N9(27);
        createClasses[107] = new N9(27);
        
        
        //Flowers
        createClasses[108] = new F1(28);
        createClasses[109] = new F2(29);
        createClasses[110] = new F3(30);
        createClasses[111] = new F4(31);
        
        
        //Seasons
        createClasses[112] = new Autumn(32);
        createClasses[113] = new Spring(33);
        createClasses[114] = new Summer(34);
        createClasses[115] = new Winter(35);
        
        
        //Dragons
        createClasses[116] = new Green(36);
        createClasses[117] = new Green(36);
        createClasses[118] = new Green(36);
        createClasses[119] = new Green(36);
        
        createClasses[120] = new Red(37);
        createClasses[121] = new Red(37);
        createClasses[122] = new Red(37);
        createClasses[123] = new Red(37);
        
        createClasses[124] = new White(38);
        createClasses[125] = new White(38);
        createClasses[126] = new White(38);
        createClasses[127] = new White(38);
        
        
        //Winds
        createClasses[128] = new East(39);
        createClasses[129] = new East(39);
        createClasses[130] = new East(39);
        createClasses[131] = new East(39);
        
        createClasses[132] = new West(40);
        createClasses[133] = new West(40);
        createClasses[134] = new West(40);
        createClasses[135] = new West(40);
        
        createClasses[136] = new North(41);
        createClasses[137] = new North(41);
        createClasses[138] = new North(41);
        createClasses[139] = new North(41);
        
        createClasses[140] = new South(42);
        createClasses[141] = new South(42);
        createClasses[142] = new South(42);
        createClasses[143] = new South(42);      
        
    }
}
